!=========================================================================
! Copyright (C) GemTalk Systems 1986-2016.  All Rights Reserved.
!
! $Id: AnsiMisc.gs 38393 2016-01-08 20:40:59Z lalmarod $
!
! Things that we want to add to base classes that reference globals
! that don't exist at the time these methods would otherwise be loaded.
!
!=========================================================================

category: 'ANSI support'
classmethod: Exception
signal: messageText

	^ExceptionA signal: messageText.
%

category: 'ANSI support'
method: Exception
handler

	^(subtype isKindOf: ExceptionHandler)
		ifTrue:  [subtype]
		ifFalse: [nil].
%

category: 'Block Evaluation'
method: ExecutableBlock
on: selector do: action
	"Try to evaluate the receiver, and should an exception occur which is matched
	by selector (normally a class object which is a subclass of ExceptionA but can
	also be an ExceptionSet instance with subclasses of ExceptionA or any other 
	object that matches the protocol defined for an ExceptionSelector), evaluate the 
	<monadicBlock>, action, passing it the exception instance as its argument."

	^ExceptionHandler new
		try: self
		on: selector
		do: action.
%
