!=========================================================================
! Copyright (C) GemTalk Systems 1986-2016.  All Rights Reserved.
!
! $Id: Notification.gs 38393 2016-01-08 20:40:59Z lalmarod $
!
!=========================================================================

removeallmethods Notification
removeallclassmethods Notification

category: 'For Documentation Installation only'
classmethod: Notification
installDocumentation

| doc txt |
doc := GsClassDocumentation newForClass: self.

txt := (GsDocText new) details:
'The class protocol describe the behavior of the global Notification. 
The value of the standard global Notification is a class object that 
conforms to this protocol. The class Notification is explicitly specified 
to be subclassable in a standard conforming program. Conforming 
implementations must implement its behaviors in a non-fragile manner.

The signaled exceptions generated by this type of object conform to 
the protocol <Notification>.

The instance protocol describes the behavior of instances of the class 
Notification. These are used to represent exceptional conditions that 
may occur but which are not considered errors. Actual notification 
exceptions used by an application may be subclasses of this class.

As Notification is explicitly specified to be subclassable, conforming 
implementations must implement its behavior in a non-fragile manner.'.
doc documentClassWith: txt.

self description: doc.
%

category: 'ANSI - signaledException'
method: Notification
defaultAction
	"No action is taken. The value 'nil' is returned as the value
	of the message that signaled the exception."

	^nil.
%

category: 'ANSI - signaledException'
method: Notification
isResumable
	"Notification exceptions by default are specified to be 'resumable'."

	^true
%
