! ========================================================================
! Copyright (C) by GemTalk Systems 1991-2016.  All Rights Reserved
!
! $Id: quadbytesymbol.gs,v 1.14.6.1 2008-04-16 18:43:00 dhenrich Exp $
!
! ========================================================================

! Create QuadByteSymbol class if not already defined (as during conversion),

expectvalue %String
run
| res cls oldCls clsName |
clsName := #QuadByteSymbol.
oldCls := Globals at:clsName otherwise: nil .
oldCls == nil ifTrue:[

  " Must be converting a pre 2.3 DB "
  " Create QuadByteSymbol "

  res := QuadByteString _newKernelSubclass: clsName
    instVarNames: #()
    classVars: #()
    classInstVars: #()
    poolDictionaries: #[]
    inDictionary: Globals
    constraints: #[] 
    instancesInvariant: false
    isModifiable: true
    reservedOop: 993.

  cls := Globals at: clsName.

  "_newKernelSubclass creates oop objects: change format to byte/indexable"
  cls _unsafeAt: 2 put: 37.

  cls immediateInvariant.

  "Add this class to the class history of Symbol"
  Symbol classHistory add: cls.

] ifFalse: [ res := clsName asString , 'already exists' ].
^ res
%

removeallmethods QuadByteSymbol
removeallclassmethods QuadByteSymbol

category: 'For Documentation Installation only'
classmethod: QuadByteSymbol
installDocumentation

| doc txt |
doc := GsClassDocumentation newForClass: self.

txt := (GsDocText new) details:

'A QuadByteSymbol is a Symbol based on QuadByteStrings using characters
 requiring 4 bytes to represent them.  This class is currently just a
 "stub", as canonical support for QuadByteSymbols has not yet
 been developed. '.
doc documentClassWith: txt.

self description: doc.
%

! ------------------- Class methods for QuadByteSymbol

category 'Instance Creation'
classmethod: QuadByteSymbol
new: aSize

^ self halt: 'not yet supported'
%

category 'Instance Creation'
classmethod: QuadByteSymbol
new

^ self halt: 'not yet supported'
%
